#
#
# $Id: indimail-mta.spec.in,v 1.247 2020-08-03 17:30:46+05:30 Cprogrammer Exp mbhangui $
%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1
%global debug_package %{nil}

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%else
%define _project           local
%global build_on_obs       0
%global reconfigure_mode   0
%global _hardened_build    1
%endif

%global _prefix            /usr
%global mandir             /usr/share/man
%global docdir             /usr/share/doc/libdkim
%global _pkg_config_path   /usr/%{_lib}/pkgconfig

%global _verbose           0

%if %build_on_obs == 1
%global packager Manvendra Bhangui <libdkim@indimail.org>
%endif

%if 0%{?suse_version}
%global dist suse
%global disttag suse
%endif

%if 0%{?fedora_version}
%global dist %{?dist}
%global disttag fedora
%endif

Summary: A Flexible SMTP server
Name: libdkim
Version: 1.5
Release: 1.2%{?dist}

%if %build_on_obs == 1
License: GPL-3.0+
%else
License: GPLv3
%endif
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: System/Libraries
%endif
Source0: http://downloads.sourceforge.net/indimail/libdkim-%{version}.tar.gz
Source1: http://downloads.sourceforge.net/indimail/libdkim-rpmlintrc

URL: https://github.com/mbhangui/indimail-mta
#AutoReqProv: No
BuildRequires: gcc gcc-c++ make autoconf automake libtool pkgconfig
BuildRequires: findutils diffutils gzip coreutils
BuildRequires: glibc glibc-devel
BuildRequires: openssl-devel

##################################### OBS ####################################
%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks
#!BuildIgnore: post-build-checks
%endif
%endif
##############################################################################
AutoReqProv: Yes
Provides: dkim-libs = %{version}
Provides: dkim-libs%{?_isa} = %{version}

%if %build_on_obs == 1
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXXX)
%endif
Requires: coreutils glibc openssl findutils pkgconfig

%description
DomainKeys Identified Mail (DKIM) defines a domain-level authentication
framework for email using public-key cryptography and key server technology
to permit verification of the source and contents of messages by either
Mail Transport Agents (MTAs) or Mail User Agents (MUAs).

libdkim is a library, developed by Alt-N Technologies, that allows
incorporating DKIM into an existing MTA or other application. It provides
full support for signing, verifying, and SSP. See the changelogs for
information on compliance with specifications.

This package contains the development files needed to compile and link
programs with libdkim.

%package devel
Summary: Development header files and static library for libdkim
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: Development/Tools/Other
%endif
Requires: libdkim = %{version}

%description devel
This package contains the development header files and libraries
necessary to applications that incorporates DKIM signing, DKIM verification
or both.

%prep
%setup -q -n libdkim-%{version}

%build
%configure --prefix=%{_prefix} --mandir=%{mandir}

%install
%if 0%{?build_cflags:1}
  CFLAGS="%{build_cflags}"
%else
  CFLAGS="%{optflags}"
%endif
%if 0%{?build_cxxflags:1}
  CXXFLAGS="%{build_cxxflags}"
%else
  CXXFLAGS="%{optflags}"
%endif
%if 0%{?build_ldflags:1}
  LDFLAGS="%{build_ldflags} -pie"
%endif
%if %{undefined centos_version} && %{undefined rhel_version}
  CFLAGS="$CFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
  CXXFLAGS="$CXXFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
%else
%if %{defined centos_version} && 0%{?centos_version} > 700
  CFLAGS="$CFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
  CXXFLAGS="$CXXFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
%endif
%if %{defined rhel_version} && 0%{?rhel_version} > 700
  CFLAGS="$CFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
  CXXFLAGS="$CXXFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
%endif
%endif
%{__make} -s %{?_smp_mflags} CC="%{__cc}" CFLAGS="$CFLAGS" CXXFLAGS="$CXXFLAGS" LDFLAGS="$LDFLAGS"
%{__make} -s %{?_smp_mflags} DESTDIR=%{buildroot} install-strip
%{__rm} -f %{buildroot}%{_libdir}/libdkim.la

%files
%defattr(-, root, root,-)
%{_libdir}/libdkim.so.1
%{_libdir}/libdkim.so.1.0.0
%doc AUTHORS COPYING README ChangeLog yahoo-patent-license-1.2.txt
%doc %attr(644,root,root)               %{mandir}/man8/dkim.8.gz

%attr(755,root,root)                    %{_prefix}/bin/dkim

%files devel
%dir %attr(755,root,root)               %{_prefix}/include/dkim

%attr(644,root,root)                    %{_prefix}/include/dkim/dkim.h
%attr(644,root,root)                    %{_prefix}/include/dkim/macros.h
%{_libdir}/libdkim.so
%{_libdir}/libdkim.a
%{_pkg_config_path}/libdkim.pc

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -fr %{buildroot}

%post
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
if [ "$argv1" -eq 2 ] ; then # upgrade
  # we are doing upgrade
  if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
    /sbin/ldconfig
  fi
fi

%postun
if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  /sbin/ldconfig
fi

%changelog
* Thu Oct 01 2020 12:26:30 +0530 libqmail@indimail.org 1.5-1.2%{?dist}
Release 1.5 Start 19/03/2009
1.  Added libdkim-1.0 - DKIM signing/verification library by ALT-N
    technologies. New program dkim for testing dkim signatures
2.  Fixed bugs with DKIM/DK verification
3.  Released libdkim-1.1
4.  Added ADSP/SSP to qmail-dkim, libdkim
5.  Added Return-Path to use as domain in dkimsign.cpp
6.  configure for libdkim detects EVP_sha256 or EVP_sha1. Fix for Mac. Fixed
    version available as libdkim-1.3
7.  Added dkim man page
8.  updates from libdkim-1.0.21
9.  dkim.c - do not skip X-Mailer headers
10. dkimsign.cpp - address parsing to fix signing of email generated by cron
    daemon
11. dkimsign.cpp - replace % in selector with domain name
12. dkim.c - Use basename of private key as the selector in absense of -y option
13. dkimverify.cpp - replace strtok() with strtok_r() for thread safe
14. refactored dns_text() function
15. use packetsize > 512 to avoid dkim failures for sites having long txt
    records (hotmail.com)
16. libdkim - removed compiler warnings
17. libdkim - added CXXFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder to configure.ac
18. libdkim - dns.cpp. fixed double free of dnresult causing SIGSEGV
19. dkim.c - fix for multiple DKIM-Signature header
20. Fixed dkimsign issue with round parenthesis.
21. dkim.c - Added missing usage string for allowing unsigned subject
22. dkimverify.cpp - made scope of sFromDomain static
23. dkimverify.cpp - Increased buffer length for dns result
24. dns.cpp - fixed pointer after realloc
25. configure.ac, dkimverify.cpp, dkimverify.h - fix for 32 bit systems
    where time_t is 4 bytes & encounters year 2038 issue
26. dkim.c - fixed return value interpretation of DKIMVERIFY
27. libdkim - dkim.c, dkimverify.h, dkimbase.cpp, dkimverify.cpp - BUG
    verfication was not honoring body length tag
28. use DKIMDOMAIN only if Return-Path, From, Sender header are empty
29. dkimsign.cpp - use X-Bounced-Address domain for DKIM signing for bounces
30. check for null domain after DKIMDOMAIN replacement
31. fixed BUG with domain assignment
32. renamed DKKIMDOMAIN to BOUNCEDOMAIN
